"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const command_1 = require("@salesforce/command");
// Initialize Messages with the current plugin directory
command_1.core.Messages.importMessagesDirectory(__dirname);
// Load the specific messages for this file. Messages from @salesforce/command, @salesforce/core,
// or any library that is using the messages framework can also be loaded this way.
const messages = command_1.core.Messages.loadMessages("sfpowerkit", "orgwideemail_verify");
let OrgWideEmail = /** @class */ (() => {
    class OrgWideEmail extends command_1.SfdxCommand {
        async run() {
            this.ux.log("This command is deprecated, It is no longer guaranteed to work, Please update your workflow with alternate solution");
            const apiversion = await this.org.getConnection().retrieveMaxApiVersion();
            const id = this.flags.emailid;
            var orgWideAddressObj = {};
            this.ux.log("Verify email " + id);
            let response = await this.org.getConnection().request({
                method: "PATCH",
                headers: {
                    "Content-Type": "application/json"
                },
                url: "/services/data/v" + apiversion + "/sobjects/OrgWideEmailAddress/" + id,
                body: JSON.stringify(orgWideAddressObj)
            });
            if (response === undefined) {
                this.ux.log(`Org wide email address verified `);
            }
        }
    }
    OrgWideEmail.description = messages.getMessage("orgWideEmailVerifyCommandDescription");
    OrgWideEmail.examples = [
        `$ sfdx sfpowerkit:org:orgwideemail:verify --username scratchOrg --emailid orgwideemailid
  `
    ];
    OrgWideEmail.flagsConfig = {
        emailid: command_1.flags.string({
            char: "i",
            description: messages.getMessage("orgWideEmailIdDescription"),
            required: true
        })
    };
    OrgWideEmail.requiresUsername = true;
    return OrgWideEmail;
})();
exports.default = OrgWideEmail;
//# sourceMappingURL=verify.js.map