"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const command_1 = require("@salesforce/command");
const relaxIPRangeImpl_1 = __importDefault(require("../../../impl/org/relaxIPRangeImpl"));
// tslint:disable-next-line:ordered-imports
var path = require("path");
const sfpowerkit_1 = require("../../../sfpowerkit");
// Initialize Messages with the current plugin directory
command_1.core.Messages.importMessagesDirectory(__dirname);
// Load the specific messages for this file. Messages from @salesforce/command, @salesforce/core,
// or any library that is using the messages framework can also be loaded this way.
const messages = command_1.core.Messages.loadMessages("sfpowerkit", "org_relaxiprange");
let Relaxiprange = /** @class */ (() => {
    class Relaxiprange extends command_1.SfdxCommand {
        async run() {
            sfpowerkit_1.SFPowerkit.setLogLevel(this.flags.loglevel, this.flags.json);
            let ipRangeToSet = this.flags.range.map(function (element) {
                let range = element.split("-");
                return { start: range[0], end: range[1] };
            });
            return await relaxIPRangeImpl_1.default.setIp(this.org.getConnection(), this.org.getUsername(), ipRangeToSet);
        }
    }
    Relaxiprange.description = messages.getMessage("commandDescription");
    Relaxiprange.examples = [
        `sfdx sfpowerkit:org:relaxiprange -u sandbox -r "122.0.0.0-122.255.255.255,49.0.0.0-49.255.255.255"`
    ];
    Relaxiprange.flagsConfig = {
        range: command_1.flags.array({
            required: true,
            char: "r",
            description: messages.getMessage("rangeFlagDescription")
        }),
        loglevel: command_1.flags.enum({
            description: "logging level for this command invocation",
            default: "info",
            required: false,
            options: [
                "trace",
                "debug",
                "info",
                "warn",
                "error",
                "fatal",
                "TRACE",
                "DEBUG",
                "INFO",
                "WARN",
                "ERROR",
                "FATAL"
            ]
        })
    };
    // Comment this out if your command does not require an org username
    Relaxiprange.requiresUsername = true;
    return Relaxiprange;
})();
exports.default = Relaxiprange;
//# sourceMappingURL=relaxiprange.js.map