"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const command_1 = require("@salesforce/command");
const rimraf = __importStar(require("rimraf"));
const sfpowerkit_1 = require("../../../sfpowerkit");
const poolCreateImpl_1 = __importDefault(require("../../../impl/pool/scratchorg/poolCreateImpl"));
const core_1 = require("@salesforce/core");
// Initialize Messages with the current plugin directory
command_1.core.Messages.importMessagesDirectory(__dirname);
// Load the specific messages for this file. Messages from @salesforce/command, @salesforce/core,
// or any library that is using the messages framework can also be loaded this way.
const messages = command_1.core.Messages.loadMessages("sfpowerkit", "scratchorg_pool_create");
let Create = /** @class */ (() => {
    class Create extends command_1.SfdxCommand {
        async run() {
            rimraf.sync("temp_sfpowerkit");
            sfpowerkit_1.SFPowerkit.setLogLevel(this.flags.loglevel, false);
            await this.hubOrg.refreshAuth();
            const hubConn = this.hubOrg.getConnection();
            this.flags.apiversion =
                this.flags.apiversion || (await hubConn.retrieveMaxApiVersion());
            let scratchOrgPoolImpl = new poolCreateImpl_1.default(this.flags.configfilepath, this.hubOrg, this.flags.apiversion);
            try {
                return !(await scratchOrgPoolImpl.poolScratchOrgs());
            }
            catch (err) {
                throw new core_1.SfdxError("Unable to execute command .. " + err);
            }
        }
    }
    Create.description = messages.getMessage("commandDescription");
    Create.requiresDevhubUsername = true;
    Create.examples = [
        `$ sfdx sfpowerkit:pool:create -f config\\core_poolconfig.json`,
        `$ sfdx sfpowerkit:pool:create -f config\\core_poolconfig.json -v devhub`
    ];
    Create.flagsConfig = {
        configfilepath: command_1.flags.filepath({
            char: "f",
            description: messages.getMessage("configFilePathDescription"),
            required: true
        }),
        loglevel: command_1.flags.enum({
            description: "logging level for this command invocation",
            default: "info",
            required: false,
            options: [
                "trace",
                "debug",
                "info",
                "warn",
                "error",
                "fatal",
                "TRACE",
                "DEBUG",
                "INFO",
                "WARN",
                "ERROR",
                "FATAL"
            ]
        })
    };
    return Create;
})();
exports.default = Create;
//# sourceMappingURL=create.js.map