"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs-extra"));
const command_1 = require("@salesforce/command");
const rimraf = __importStar(require("rimraf"));
const core_1 = require("@salesforce/core");
const xml2js = __importStar(require("xml2js"));
const util = __importStar(require("util"));
const fg = require("fast-glob");
const sfpowerkit_1 = require("../../../../sfpowerkit");
var path = require("path");
// Initialize Messages with the current plugin directory
command_1.core.Messages.importMessagesDirectory(__dirname);
// Load the specific messages for this file. Messages from @salesforce/command, @salesforce/core,
// or any library that is using the messages framework can also be loaded this way.
const messages = command_1.core.Messages.loadMessages("sfpowerkit", "apextestsuite_convert");
let Convert = /** @class */ (() => {
    class Convert extends command_1.SfdxCommand {
        async run() {
            rimraf.sync("temp_sfpowerkit");
            sfpowerkit_1.SFPowerkit.setLogLevel(this.flags.loglevel, this.flags.json);
            const entries = fg.sync(`**${this.flags.name}.testSuite-meta.xml`, {
                onlyFiles: true,
                absolute: true,
                baseNameMatch: true
            });
            if (!entries[0])
                throw new core_1.SfdxError(`Apex Test Suite ${this.flags.name} not found`);
            sfpowerkit_1.SFPowerkit.log(`Apex Test Suite File Path ${entries[0]}`, core_1.LoggerLevel.DEBUG);
            if (fs.existsSync(path.resolve(entries[0]))) {
                const parser = new xml2js.Parser({ explicitArray: false });
                const parseString = util.promisify(parser.parseString);
                let apex_test_suite = await parseString(fs.readFileSync(path.resolve(entries[0])));
                let testclasses;
                const doublequote = '"';
                if (apex_test_suite.ApexTestSuite.testClassName.constructor === Array) {
                    testclasses =
                        doublequote +
                            apex_test_suite.ApexTestSuite.testClassName.join() +
                            doublequote;
                }
                else {
                    testclasses =
                        doublequote +
                            apex_test_suite.ApexTestSuite.testClassName +
                            doublequote;
                }
                this.ux.log(testclasses);
                return testclasses;
            }
            else {
                throw new core_1.SfdxError("Apex Test Suite not found");
            }
        }
    }
    // Set this to true if your command requires a project workspace; 'requiresProject' is false by default
    Convert.requiresProject = true;
    Convert.description = messages.getMessage("commandDescription");
    Convert.examples = [
        `$ sfdx sfpowerkit:source:apextestsuite:convert -n MyApexTestSuite 
    "ABC2,ABC1Test"    
  `
    ];
    Convert.flagsConfig = {
        name: command_1.flags.string({
            required: true,
            char: "n",
            description: messages.getMessage("nameFlagDescription")
        }),
        loglevel: command_1.flags.enum({
            description: "logging level for this command invocation",
            default: "info",
            required: false,
            options: [
                "trace",
                "debug",
                "info",
                "warn",
                "error",
                "fatal",
                "TRACE",
                "DEBUG",
                "INFO",
                "WARN",
                "ERROR",
                "FATAL"
            ]
        })
    };
    return Convert;
})();
exports.default = Convert;
//# sourceMappingURL=convert.js.map