"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const _ = __importStar(require("lodash"));
const baseMetadataRetriever_1 = __importDefault(require("./baseMetadataRetriever"));
const metadataInfo_1 = require("../metadataInfo");
const metadataFiles_1 = __importDefault(require("../metadataFiles"));
const sfpowerkit_1 = require("../../../sfpowerkit");
const sfpowerkit_2 = require("../../../sfpowerkit");
const QUERY = "SELECT DurableId, DeveloperName, QualifiedApiName, NamespacePrefix FROM EntityDefinition order by QualifiedApiName";
class EntityDefinitionRetriever extends baseMetadataRetriever_1.default {
    constructor(org) {
        super(org, false);
        this.org = org;
        super.setQuery(QUERY);
    }
    static getInstance(org) {
        if (!EntityDefinitionRetriever.instance) {
            EntityDefinitionRetriever.instance = new EntityDefinitionRetriever(org);
        }
        return EntityDefinitionRetriever.instance;
    }
    async getObjects() {
        let resultPromise = new Promise((resolve, reject) => {
            this.org.getConnection().describeGlobal(function (err, res) {
                if (err) {
                    sfpowerkit_1.SFPowerkit.log(`Error when running gllobal describe `, sfpowerkit_2.LoggerLevel.ERROR);
                    sfpowerkit_1.SFPowerkit.log(err, sfpowerkit_2.LoggerLevel.ERROR);
                    reject(err);
                }
                else {
                    sfpowerkit_1.SFPowerkit.log(`Org describe completed successfully. ${res.sobjects.length} object found! `, sfpowerkit_2.LoggerLevel.INFO);
                    let entities = res.sobjects.map(sObject => {
                        return {
                            QualifiedApiName: sObject.name
                        };
                    });
                    resolve(entities);
                }
            });
        });
        return resultPromise;
    }
    async getEntityDefinitions() {
        return await this.getObjects();
    }
    async getObjectForPermission() {
        if (this.objectForPermission && this.objectForPermission.length > 0) {
            return this.objectForPermission;
        }
        this.objectForPermission = [];
        await this.org.refreshAuth();
        let res = await this.org
            .getConnection()
            .query("SELECT SobjectType, count(Id) From ObjectPermissions Group By sObjectType");
        if (res !== undefined) {
            this.objectForPermission = res.records.map(elem => {
                return elem["SobjectType"];
            });
        }
        if (!this.objectForPermission.includes("PersonAccount")) {
            this.objectForPermission.push("PersonAccount");
        }
        return this.objectForPermission;
    }
    async existObjectPermission(object) {
        let found = false;
        //Look first in project files
        if (!_.isNil(metadataInfo_1.METADATA_INFO.CustomObject.components)) {
            found = metadataInfo_1.METADATA_INFO.CustomObject.components.includes(object);
        }
        if (!found && !metadataFiles_1.default.sourceOnly) {
            //not found, check on the org
            let objects = await this.getObjectForPermission();
            found = objects.includes(object);
        }
        return found;
    }
    async existCustomMetadata(custonObjectStr) {
        let found = false;
        //Look first in project files
        if (!_.isNil(metadataInfo_1.METADATA_INFO.CustomObject.components)) {
            found = metadataInfo_1.METADATA_INFO.CustomObject.components.includes(custonObjectStr);
        }
        if (!found && !metadataFiles_1.default.sourceOnly) {
            //not found, check on the org
            let objects = await this.getObjects();
            let foundObj = objects.find(obj => {
                return obj.QualifiedApiName === custonObjectStr;
            });
            found = foundObj !== undefined;
        }
        return found;
    }
}
exports.default = EntityDefinitionRetriever;
//# sourceMappingURL=entityDefinitionRetriever.js.map