"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const metadataInfo_1 = require("../metadataInfo");
const _ = __importStar(require("lodash"));
const baseMetadataRetriever_1 = __importDefault(require("./baseMetadataRetriever"));
const metadataFiles_1 = __importDefault(require("../metadataFiles"));
const QUERY = "SELECT Id, Name, EntityDefinition.QualifiedApiName, EntityDefinitionId, NamespacePrefix From Layout  ";
class LayoutRetriever extends baseMetadataRetriever_1.default {
    constructor(org) {
        super(org, true);
        this.org = org;
        super.setQuery(QUERY);
    }
    static getInstance(org) {
        if (!LayoutRetriever.instance) {
            LayoutRetriever.instance = new LayoutRetriever(org);
        }
        return LayoutRetriever.instance;
    }
    async getObjects() {
        if ((this.data === undefined || this.data.length == 0) &&
            !this.dataLoaded) {
            super.setQuery(QUERY);
            let layouts = await super.getObjects();
            for (let i = 0; i < layouts.length; i++) {
                let namespace = "";
                if (layouts[i].NamespacePrefix !== undefined &&
                    layouts[i].NamespacePrefix !== "" &&
                    layouts[i].NamespacePrefix !== null &&
                    layouts[i].NamespacePrefix !== "null") {
                    namespace = layouts[i].NamespacePrefix + "__";
                }
                if (layouts[i].EntityDefinition !== null &&
                    layouts[i].EntityDefinition !== undefined) {
                    layouts[i].FullName =
                        layouts[i].EntityDefinition.QualifiedApiName +
                            "-" +
                            namespace +
                            layouts[i].Name.replace(/%/g, "%25")
                                .replace(/\//g, "%2F")
                                .replace(new RegExp(/\\/, "g"), "%5C")
                                .replace(/\(/g, "%28")
                                .replace(/\)/g, "%29")
                                .replace(/#/g, "%23")
                                .replace(/\$/g, "%24")
                                .replace(/&/g, "%26")
                                .replace(/~/g, "%7E")
                                .replace(/\[/g, "%5B")
                                .replace(/\]/g, "%5D")
                                .replace(/\^/g, "%5E")
                                .replace(/\{/g, "%7B")
                                .replace(/\}/g, "%7D")
                                .replace(/\|/g, "%7C")
                                .replace(/@/g, "%40")
                                .replace(/'/g, "%27");
                }
                else {
                    layouts[i].FullName =
                        layouts[i].EntityDefinitionId +
                            "-" +
                            namespace +
                            layouts[i].Name.replace(/%/g, "%25")
                                .replace(/\//g, "%2F")
                                .replace(new RegExp(/\\/, "g"), "%5C")
                                .replace(/\(/g, "%28")
                                .replace(/\)/g, "%29")
                                .replace(/#/g, "%23")
                                .replace(/\$/g, "%24")
                                .replace(/&/g, "%26")
                                .replace(/~/g, "%7E")
                                .replace(/\[/g, "%5B")
                                .replace(/\]/g, "%5D")
                                .replace(/\^/g, "%5E")
                                .replace(/\{/g, "%7B")
                                .replace(/\}/g, "%7D")
                                .replace(/\|/g, "%7C")
                                .replace(/@/g, "%40")
                                .replace(/'/g, "%27");
                }
            }
            this.data = layouts;
            this.dataLoaded = true;
        }
        return this.data;
    }
    async getLayouts() {
        return await this.getObjects();
    }
    async layoutExists(layout) {
        let found = false;
        //Look first in project files
        if (!_.isNil(metadataInfo_1.METADATA_INFO.Layout.components)) {
            found = metadataInfo_1.METADATA_INFO.Layout.components.includes(layout);
        }
        if (!found && !metadataFiles_1.default.sourceOnly) {
            //not found, check on the org
            let layouts = await this.getLayouts();
            let foundLayout = layouts.find(l => {
                return l.FullName === layout;
            });
            found = !_.isNil(foundLayout);
        }
        return found;
    }
}
exports.default = LayoutRetriever;
//# sourceMappingURL=layoutRetriever.js.map