"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const metadataInfo_1 = require("../metadataInfo");
const _ = __importStar(require("lodash"));
const baseMetadataRetriever_1 = __importDefault(require("./baseMetadataRetriever"));
const metadataFiles_1 = __importDefault(require("../metadataFiles"));
const QUERY = "Select Id, Name, DeveloperName, SobjectType, NamespacePrefix from RecordType";
class RecordTypeRetriever extends baseMetadataRetriever_1.default {
    constructor(org) {
        super(org);
        this.org = org;
        super.setQuery(QUERY);
    }
    static getInstance(org) {
        if (!RecordTypeRetriever.instance) {
            RecordTypeRetriever.instance = new RecordTypeRetriever(org);
        }
        return RecordTypeRetriever.instance;
    }
    async getObjects() {
        if ((this.data === undefined || this.data.length == 0) &&
            !this.dataLoaded) {
            let objects = await super.getObjects();
            objects = objects.map(elem => {
                let namespace = "";
                if (elem.NamespacePrefix !== undefined &&
                    elem.NamespacePrefix !== "" &&
                    elem.NamespacePrefix !== null &&
                    elem.NamespacePrefix !== "null") {
                    namespace = elem.NamespacePrefix + "__";
                }
                elem.FullName = elem.SobjectType + "." + namespace + elem.DeveloperName;
                if (elem.DeveloperName === "PersonAccount" &&
                    elem.SobjectType === "Account") {
                    elem.FullName =
                        "PersonAccount" + "." + namespace + elem.DeveloperName;
                }
                return elem;
            });
            this.data = objects;
            this.dataLoaded = true;
        }
        return this.data;
    }
    async getrecordTypes() {
        return await this.getObjects();
    }
    async recordTypeExists(recordType) {
        let found = false;
        //Look first in project files
        if (!_.isNil(metadataInfo_1.METADATA_INFO.RecordType.components)) {
            found = metadataInfo_1.METADATA_INFO.RecordType.components.includes(recordType);
        }
        if (!found && !metadataFiles_1.default.sourceOnly) {
            //not found, check on the org
            let recordTypes = await this.getrecordTypes();
            let foundRecordType = recordTypes.find(rt => {
                return rt.FullName === recordType;
            });
            found = !_.isNil(foundRecordType);
        }
        return found;
    }
}
exports.default = RecordTypeRetriever;
//# sourceMappingURL=recordTypeRetriever.js.map