"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const metadataInfo_1 = require("../metadataInfo");
const _ = __importStar(require("lodash"));
const baseMetadataRetriever_1 = __importDefault(require("./baseMetadataRetriever"));
const metadataFiles_1 = __importDefault(require("../metadataFiles"));
const QUERY = "SELECT Id,  Name, SobjectName, DurableId, IsCustom, Label FROM TabDefinition ";
class TabDefinitionRetriever extends baseMetadataRetriever_1.default {
    constructor(org) {
        super(org, true);
        this.org = org;
        super.setQuery(QUERY);
    }
    static getInstance(org) {
        if (!TabDefinitionRetriever.instance) {
            TabDefinitionRetriever.instance = new TabDefinitionRetriever(org);
        }
        return TabDefinitionRetriever.instance;
    }
    async getObjects() {
        if ((this.data === undefined || this.data.length == 0) &&
            !this.dataLoaded) {
            super.setQuery(QUERY);
            let tabs = await super.getObjects();
            this.data = tabs;
            this.dataLoaded = true;
        }
        return this.data;
    }
    async getTabs() {
        return await this.getObjects();
    }
    async tabExists(tab) {
        let found = false;
        //Look first in project files
        if (!_.isNil(metadataInfo_1.METADATA_INFO.CustomTab.components)) {
            found = metadataInfo_1.METADATA_INFO.CustomTab.components.includes(tab);
        }
        if (!found && !metadataFiles_1.default.sourceOnly) {
            //not found, check on the org
            let tabs = await this.getTabs();
            let foundTab = tabs.find(t => {
                return t.Name === tab;
            });
            found = !_.isNil(foundTab);
        }
        return found;
    }
}
exports.default = TabDefinitionRetriever;
//# sourceMappingURL=tabDefinitionRetriever.js.map