"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProgressBar = void 0;
const cli_ux_1 = __importDefault(require("cli-ux"));
const util_1 = require("util");
const sfpowerkit_1 = require("../sfpowerkit");
class ProgressBar {
    create(title, unit, displayTillLogLevel) {
        if (sfpowerkit_1.SFPowerkit.logLevel <= displayTillLogLevel &&
            !sfpowerkit_1.SFPowerkit.isJsonFormatEnabled) {
            this.progressBarImpl = cli_ux_1.default.progress({
                format: `${title} - PROGRESS  | {bar} | {value}/{total} ${unit}`,
                barCompleteChar: "\u2588",
                barIncompleteChar: "\u2591",
                linewrap: true
            });
        }
        return this;
    }
    start(totalSize) {
        if (!util_1.isNullOrUndefined(this.progressBarImpl))
            this.progressBarImpl.start(totalSize);
    }
    stop() {
        if (!util_1.isNullOrUndefined(this.progressBarImpl))
            this.progressBarImpl.stop();
    }
    increment(count) {
        if (!util_1.isNullOrUndefined(this.progressBarImpl))
            this.progressBarImpl.increment(count);
    }
}
exports.ProgressBar = ProgressBar;
//# sourceMappingURL=progressBar.js.map