"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.checkDeploymentStatus = void 0;
const delay_1 = require("./delay");
const sfpowerkit_1 = require("../sfpowerkit");
const core_1 = require("@salesforce/core");
async function checkDeploymentStatus(conn, retrievedId) {
    let metadata_result;
    while (true) {
        await conn.metadata.checkDeployStatus(retrievedId, true, function (error, result) {
            if (error) {
                throw new core_1.SfdxError(error.message);
            }
            metadata_result = result;
        });
        if (!metadata_result.done) {
            sfpowerkit_1.SFPowerkit.log("Polling for Deployment Status", core_1.LoggerLevel.INFO);
            await delay_1.delay(5000);
        }
        else {
            break;
        }
    }
    return metadata_result;
}
exports.checkDeploymentStatus = checkDeploymentStatus;
//# sourceMappingURL=checkDeploymentStatus.js.map