"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DXProjectManifestUtils = void 0;
const path = __importStar(require("path"));
const fs = __importStar(require("fs-extra"));
class DXProjectManifestUtils {
    constructor(projectFolder) {
        this.projectFolder = projectFolder;
    }
    removePackagesNotInDirectory() {
        //Validate projectJson Path
        let sfdxProjectManifestPath = path.join(this.projectFolder, "sfdx-project.json");
        if (!fs.existsSync(sfdxProjectManifestPath))
            throw new Error(`sfdx-project.json doesn't exist at ${sfdxProjectManifestPath}`);
        // Read sfdx-projec.json
        const sfdxProjectManifest = fs.readFileSync(sfdxProjectManifestPath, "utf8");
        this.sfdxProjectManifestJSON = JSON.parse(sfdxProjectManifest);
        //Filter sfdx-project.json of unwanted directories
        this.sfdxProjectManifestJSON.packageDirectories = this.sfdxProjectManifestJSON.packageDirectories.filter(el => this.isElementExists(el));
        //write back sfdx-project.json back
        fs.writeJSONSync(sfdxProjectManifestPath, this.sfdxProjectManifestJSON);
    }
    isElementExists(element) {
        return fs.existsSync(path.join(this.projectFolder, element.path));
    }
}
exports.DXProjectManifestUtils = DXProjectManifestUtils;
//# sourceMappingURL=dxProjectManifestUtils.js.map