"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path = __importStar(require("path"));
const sfpowerkit_1 = require("../sfpowerkit");
const fs = __importStar(require("fs-extra"));
const fileutils_1 = __importDefault(require("./fileutils"));
class OutputGenerator {
    async generateJsonOutput(result, outputDir) {
        let outputJsonPath = `${outputDir}/output.json`;
        let dir = path.parse(outputJsonPath).dir;
        if (!fs.existsSync(dir)) {
            fileutils_1.default.mkDirByPathSync(dir);
        }
        fs.writeFileSync(outputJsonPath, JSON.stringify(result));
        sfpowerkit_1.SFPowerkit.log(`Output ${outputDir}/output.json is generated successfully`, sfpowerkit_1.LoggerLevel.INFO);
    }
    async generateCSVOutput(result, outputDir) {
        let outputcsvPath = `${outputDir}/output.csv`;
        let dir = path.parse(outputcsvPath).dir;
        if (!fs.existsSync(dir)) {
            fileutils_1.default.mkDirByPathSync(dir);
        }
        fs.writeFileSync(outputcsvPath, result);
        sfpowerkit_1.SFPowerkit.log(`Output ${outputDir}/output.csv is generated successfully`, sfpowerkit_1.LoggerLevel.INFO);
    }
}
exports.default = OutputGenerator;
//# sourceMappingURL=outputGenerator.js.map