"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.retrieveMetadata = void 0;
async function retrieveMetadata(types, connection) {
    const apiversion = await connection.retrieveMaxApiVersion();
    let toReturn = new Promise((resolve, reject) => {
        connection.metadata.list(types, apiversion, function (err, metadata) {
            if (err) {
                return reject(err);
            }
            let metadata_fullnames = [];
            for (let i = 0; i < metadata.length; i++) {
                metadata_fullnames.push(metadata[i].fullName);
            }
            resolve(metadata_fullnames);
        });
    });
    return toReturn;
}
exports.retrieveMetadata = retrieveMetadata;
//# sourceMappingURL=retrieveMetadata.js.map